import { User } from "../../generated/client";

export interface PublicUser {
	firstname: string;
	lastname: string;
	publicId: string;
	badges: string[];
	fullName: string;
}

export const DISCORD_ROLES = {
	ONLINE_DISPATCHER: "1287399540390891571", // Replace with actual role ID
	ONLINE_PILOT: "1287399540390891571", // Replace with actual role ID
	DISPATCHER: "1081247459994501222",
	PILOT: "1081247405304975390",
};

export const getPublicUser = (
	user: User,
	options = {
		ignorePrivacy: false,
	},
): PublicUser => {
	return {
		firstname: user.firstname,
		lastname:
			user.settingsHideLastname && !options.ignorePrivacy
				? ""
				: user.lastname
						.split(" ")
						.map((part) => `${part[0]}.`)
						.join(" "), // Only take the first part of the name
		fullName: `${user.firstname} ${user.lastname
			.split(" ")
			.map((part) => `${part[0]}.`)
			.join(" ")}`,
		publicId: user.publicId,
		badges: user.badges,
	};
};

export const asPublicUser = (publicUSerJson: unknown): PublicUser => {
	if (typeof publicUSerJson !== "object" || publicUSerJson === null) {
		throw new Error("Invalid JSON format for PublicUser");
	}
	return publicUSerJson as PublicUser;
};
